/***********************************************************
 * $Id: fancyqt4.h 1111 2014-01-08 15:28:01Z fancylibs $
 *
 * FancyQT4
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQT4_H_
#define FANCYQT4_H_

#ifdef WIN32
# ifdef FANCYQT4_SHARED_LIBRARY
#  ifdef __GNUC__
#   ifdef BUILD_fancy3qt4_DLL
#    define FANCYQT4_API __attribute__((dllexport))
#    define FANCYQT4_I18N_API __attribute__((dllexport,format_arg (1)))
#    define FANCYQT4_I18N_N_API __attribute__((dllexport,format_arg (1),format_arg (2)))
#   else
#    define FANCYQT4_API __attribute__((dllimport))
#    define FANCYQT4_I18N_API __attribute__((dllimport,format_arg (1)))
#    define FANCYQT4_I18N_N_API __attribute__((dllimport,format_arg (1),format_arg (2)))
#   endif
#  else
#   ifdef FANCYQT4_BUILD_SLIB
#    define FANCYQT4_API __declspec(dllexport)
#   else
#    define FANCYQT4_API __declspec(dllimport)
#   endif
#  endif
# else
#  define FANCYQT4_I18N_API __attribute__((format_arg (1)))
#  define FANCYQT4_I18N_N_API __attribute__((format_arg (1),format_arg (2)))
# endif
#else
# ifdef __GNUC__
#  define FANCYQT4_INTERNAL_API __attribute__((visibility("hidden")))
#  define FANCYQT4_I18N_API __attribute__((format_arg (1)))
#  define FANCYQT4_I18N_N_API __attribute__((format_arg (1),format_arg (2)))
# endif
#endif

#ifndef FANCYQT4_INTERNAL_API
#define FANCYQT4_INTERNAL_API
#endif

#ifndef FANCYQT4_API
#define FANCYQT4_API
#endif

#ifndef FANCYQT4_I18N_API
#define FANCYQT4_I18N_API FANCYQT4_API
#endif

#ifndef FANCYQT4_I18N_N_API
#define FANCYQT4_I18N_N_API FANCYQT4_API
#endif

#endif /* FANCYQT4_H_ */
