/***********************************************************
 * $Id: fancyqt4onewayinvocationcallemitter.h 994 2013-10-07 14:51:41Z fancylibs $
 *
 * FancyQT4
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_
#define FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_

#include "fancyqt4.h"
#include "fancyqt4onewayinvocationcall.h"

#include <fancyobject.h>

#include <QtCore/qobject.h>


namespace Fancy {

namespace Qt4 {

/**
 * A sender object to propagate a OneWayHandler's doOneWay() call asynchronously invocation to a GUI component.
 */
class FANCYQT4_API OneWayInvocationCallEmitter : public QObject {

    Q_OBJECT

public:

    /**
     * Construct a OneWayInvocationCallEmitter
     * @param parent An optional parent object.
     * return A new instance.
     */
    OneWayInvocationCallEmitter(QObject * parent = 0);

    virtual ~OneWayInvocationCallEmitter();

    /**
     * This signal is emitted when a oneway invocation call occurs.
     *
     * @param call The POJO with the data from Fancy::Sock::OneWayHandler.doOneWay(...)
     */
    Q_SIGNAL void oneWayInvocationCallReceived(const Fancy::Qt4::OneWayInvocationCall::ptr_t &call);

};

}} // end namespaces

#endif /* FANCYQT4ONEWAYINVOCATIONCALLEMITTER_H_ */
